import os
import sys
from libfptr10 import IFptr
from datetime import datetime


DRIVER_PATH = os.path.join(os.getcwd(), 'fptr10.dll')
fptr = IFptr(DRIVER_PATH)

STATUS_STATE_STR = ''


def start():
    try:
        while True:
            print('')
            command = input('Input "check" or Ctrl+C # ')
            if command == 'check':
                IP = input('Input ip address # ')
                #IP = '192.168.53.155'
                PORT = "5555"
                SOCKET_KKM = '{}:{}'.format(IP, PORT)

                none_time = datetime(1970, 1, 1, 0)


                fptr.setSingleSetting(IFptr.LIBFPTR_SETTING_MODEL, str(IFptr.LIBFPTR_MODEL_ATOL_AUTO))
                fptr.setSingleSetting(IFptr.LIBFPTR_SETTING_PORT, str(IFptr.LIBFPTR_PORT_TCPIP))
                fptr.setSingleSetting(IFptr.LIBFPTR_SETTING_IPADDRESS, IP)
                fptr.setSingleSetting(IFptr.LIBFPTR_SETTING_IPPORT, PORT)
                result = fptr.applySingleSettings()

                try:
                    fptr.open()
                    isOpened = fptr.isOpened()
                    if isOpened == 0:
                        print('')
                        print('No connection with {}\n'.format(SOCKET_KKM))
                    print('')
                    print('Connection with {} was successful\n'.format(SOCKET_KKM))

                    fptr.setParam(IFptr.LIBFPTR_PARAM_DATA_TYPE, IFptr.LIBFPTR_DT_STATUS)
                    fptr.queryData()

                    NUMBER_KKT = fptr.getParamString(IFptr.LIBFPTR_PARAM_SERIAL_NUMBER)
                    #STATUS_STATE = fptr.getParamInt(IFptr.LIBFPTR_PARAM_SHIFT_STATE)
                    KKM_TIME = fptr.getParamDateTime(IFptr.LIBFPTR_PARAM_DATE_TIME)


                    # Обмен с ОФН
                    fptr.setParam(IFptr.LIBFPTR_PARAM_FN_DATA_TYPE, IFptr.LIBFPTR_FNDT_OFD_EXCHANGE_STATUS)
                    fptr.fnQueryData()

                    NOT_TRANS_DOC = fptr.getParamInt(IFptr.LIBFPTR_PARAM_DOCUMENTS_COUNT)
                    DATA_LAST_TRANS = fptr.getParamDateTime(IFptr.LIBFPTR_PARAM_DATE_TIME)
                    DATA_FN_KEY = fptr.getParamDateTime(IFptr.LIBFPTR_PARAM_LAST_SUCCESSFUL_OKP)

                    #if STATUS_STATE == 0:
                        #STATUS_STATE_STR = 'Закрыта'
                    #elif STATUS_STATE == 1:
                        #STATUS_STATE_STR = 'Открыта'
                    #elif STATUS_STATE == 2:
                        #STATUS_STATE_STR = 'Истекла'


                    if int(NOT_TRANS_DOC) > 0:
                        if DATA_FN_KEY == none_time:
                            print('{}; ККМ №: {}; Дата/Время: {}; Непереданные чеки: {}; Первый непереданный: {};'.format(
                            SOCKET_KKM, NUMBER_KKT, KKM_TIME, NOT_TRANS_DOC, DATA_LAST_TRANS))
                        else:
                            print('{}; ККМ №: {}; Дата/Время: {}; Непереданные чеки: {}; Первый непереданный: {}; Дата/время последнего ОКП: {};'.format(
                                SOCKET_KKM, NUMBER_KKT, KKM_TIME, NOT_TRANS_DOC, DATA_LAST_TRANS, DATA_FN_KEY))
                    else:
                        if DATA_FN_KEY == none_time:
                            print('{}; ККМ №: {}; Дата/Время: {}; Непереданные чеки: {};'.format(
                            SOCKET_KKM, NUMBER_KKT, KKM_TIME, NOT_TRANS_DOC))
                        else:
                            print('{}; ККМ №: {}; Дата/Время: {}; Непереданные чеки: {}; Дата/время последнего ОКП: {};'.format(
                                SOCKET_KKM, NUMBER_KKT, KKM_TIME, NOT_TRANS_DOC, DATA_FN_KEY))


                    # debugger
                    # print(fptr.errorDescription())
                    fptr.close()

                except Exception as e:
                    print(e)
                    fptr.close()
            else:
                print('Wrong command')
    except KeyboardInterrupt:
        sys.exit()


if __name__ == '__main__':
    os.system('color a')
    start()
